#!/usr/bin/python
from optparse import OptionParser
import os

# main
def main():
        p = OptionParser()
      	p.add_option('--first', dest="firstDir", default="/media/DATI/Cleaned_Texts_BC/WF/", help="Matrix related to the kwd only")
        p.add_option('--second', dest="secondDir", default="/media/DATI/Cleaned_Texts_BC_Old/WF/", help="Matrix related to the abstract only")
        p.add_option('--report', dest="reportFile", default="F:\\report.txt", help="Matrix related to the abstract only")
	p.add_option("--linux", dest="linuxOrNot", default="linux", help="If not set -> working under Windows; if set to linux working under Linux")
	
	option, arguments = p.parse_args()

	if option.linuxOrNot == "linux" :
		firstDir = option.firstDir.replace("F:\\", "/media/DATI/")
		firstDir = firstDir.replace('\\', '/')
		secondDir = option.secondDir.replace("F:\\", "/media/DATI/")
		secondDir = secondDir.replace('\\', '/')
		reportFile = option.reportFile.replace("F:\\", "/media/DATI/")
		reportFile = reportFile.replace('\\', '/')
	else :
		firstDir = option.firstDir
		secondDir = option.secondDir
		reportFile = option.reportFile

	counterDoc = 0

	fw = open (os.path.normpath(reportFile), mode='w')

	for fileName in os.listdir(firstDir) :
		file1 = os.path.normpath(firstDir + os.sep + fileName)
		file2 = os.path.normpath(secondDir + os.sep + fileName)

		f1 = open (file1, mode='r')
		f2 = open (file2, mode='r')

		counter1 = counter2 = 0

		for line1 in f1 : 
			counter1 += 1
		for line2 in f2 : 
			counter2 += 1

		if (counter1 != counter2) :
			#print file1, " has ", counter1, " lines; ", file2, " has ", counter1, " lines"
			fw.write(file1+" has "+str(counter1)+ " lines; " + file2 + " has "+ str(counter1)+ " lines\n")
			continue;						

		f1.close()
		f2.close()		
		f1 = open (file1, mode='r')
		f2 = open (file2, mode='r')			

		line1 = f1.readline()
		line2 = f2.readline()
		i = 0
		while ( line1 != "" and line2 != "") :
			if (line1 != line2) :
				fw.write(file1+ " ("+line1.strip()+") and "+ file2+" ("+line2.strip()+"): line "+ str(i)+" is different\n")
				#print file1, " and ", file2, ": line ", i, " is different" 
			i+=1
			line1 = f1.readline()
			line2 = f2.readline()
		#print i, " lines processed"
		counterDoc += 1
	print counterDoc, " files processed"
	fw.write(str(counterDoc)+ " files processed\n")
	f1.close()
	f2.close()
	fw.close()
	return	

if __name__ == '__main__':
	main()
