#!/usr/bin/pyhton2.5
from xml.etree.ElementTree import ElementTree
from optparse import OptionParser
import os

def main():
        p = OptionParser()
        p.add_option("--sourcePath", "-s", dest="dirnameNB", default="F:\\Cleaned_Texts\\", help="Absolute path of the directory where articles (after having been processed by the cleaner) are stored")   
        p.add_option("--suffix", "-n", dest="wSuffixNB", default="W_FN", help="Suffix to be added to the weight file related to the processed article")
        p.add_option("--linux", "-l", dest="linuxOrNot", default="", help="If not set -> working under Windows; if set to linux working under Linux")
        
        option, arguments = p.parse_args()

        if option.linuxOrNot == "linux" :
                dirname = option.dirnameNB.replace('%20', ' ')
		dirname = option.dirname.replace("F:\\", "/media/DATI/")
		dirname = dirname.replace('\\', '/')
		wSuffix = option.wSuffixNB.replace('%20', ' ')		
	else :
                dirname = option.dirnameNB.replace('%20', ' ')
		wSuffix = option.wSuffixNB.replace('%20', ' ')


        print " --- Working directory --- "
        print
        print "Source directory: "+dirname
        print

	print " --- List of the processed files --- "
        print
        
        i = 1
        for fileName in os.listdir(dirname) :

                if ( fileName.find(wSuffix) != -1 ) :
                
                        # Absolute path and name of the source file
                        source = os.path.normpath(dirname+os.sep+fileName)
                        print str(i)+ ")"
                        print "Source: " + source
                        os.remove(source)
                        i += 1        
        return

if __name__ == "__main__":
	# Someone is launching this directly
	main()
