#!/usr/bin/python
from optparse import OptionParser
import os

# main
def main():
        p = OptionParser()
      	p.add_option('--kwdFile', dest="kwdFileNameW", default="F:\\Rand\\RowLabels_k.rlabel", help="Matrix related to the kwd only")
        p.add_option('--absFile', dest="absFileNameW", default="F:\\Rand\\RowLabels_ab.rlabel", help="Matrix related to the abstract only")
	p.add_option('--bdyFile', dest="bdyFileNameW", default="F:\\Rand\\RowLabels_b.rlabel", help="Matrix related to the body only")
        p.add_option('--absbdyFile', dest="absbdyFileNameW", default="F:\\Rand\\RowLabels_abbd.rlabel", help="Matrix related to the abstract and to the body")
	
	option, arguments = p.parse_args()

	kwdFileName = option.kwdFileNameW.replace("F:\\", "/media/DATI/")
	kwdFileName = kwdFileName.replace('\\', '/')
	absFileName = option.absFileNameW.replace("F:\\", "/media/DATI/")
	absFileName = absFileName.replace('\\', '/')
	bdyFileName = option.bdyFileNameW.replace("F:\\", "/media/DATI/")
	bdyFileName = bdyFileName.replace('\\', '/')
	absbdyFileName = option.absbdyFileNameW.replace("F:\\", "/media/DATI/")
	absbdyFileName = absbdyFileName.replace('\\', '/')

	f1 = open (kwdFileName, mode='r')
	f2 = open (absFileName, mode='r')
	f3 = open (absbdyFileName, mode='r')
	f4 = open (bdyFileName, mode='r')

	line1 = f1.readline()
	line2 = f2.readline()
	line3 = f3.readline()
	line4 = f4.readline()
	i = 0

	while ( line1 != "" and line2 != "" and  line3 != "" and  line4 != "") :
		s1= line1[line1.find("_Results_KWD")+15:line1.find("_clean")]
		s2= line2[line2.find("_Results_KWD")+15:line2.find("_clean")]
		s3= line3[line3.find("_Results_KWD")+13:line3.find("_clean")]
		s4= line4[line4.find("_Results_KWD")+15:line4.find("_clean")]
		#print "s1 ", s1, " s2 ", s2, " s3 ", s3
		if (s1 != s2 or s2 != s3 or s1 != s3 or s1 != s4 or s2 != s4 or s3 != s4) :
			print "line ", i, " is different" 
		i+=1
		line1 = f1.readline()
		line2 = f2.readline()
		line3 = f3.readline()
		line4 = f4.readline()
	print i, " lines processed"
	f1.close()
	f2.close()
	f3.close()
	f4.close()
		

	

if __name__ == '__main__':
	main()
