#!/usr/bin/pyhton2.5
from optparse import OptionParser
import os
import time
import subprocess
import shutil

def main():
        p = OptionParser()
 
        p.add_option("--workDirectory", "-w",   dest="workDirNameW",            default="F:\\@_Lorenzo\\@_Tesi\\@_Framework_Parts", help="Absolute path of the directory pieces of the framework are stored")
	p.add_option("--goldDirectory", "-g",   dest="goldDirNameW",            default="F:\\Text_Selection_STAT_with_info_ABBD\\", help="Absolute path of the directory where articles are stored (once processed with the cleaner)")
##	p.add_option("--orgDirectory",  "-t",   dest="textDirNameW",            default="F:\\pubmed\\Jews\\", help="Absolute path of the directory where articles are stored (once processed with the cleaner)")
##	p.add_option("--orgDirectory",  "-t",   dest="textDirNameW",            default="F:\\pubmed\\Vaccin\\", help="Absolute path of the directory where articles are stored (once processed with the cleaner)")
##	p.add_option("--orgDirectory",  "-t",   dest="textDirNameW",            default="F:\\pubmed\\Osteoclast\\", help="Absolute path of the directory where articles are stored (once processed with the cleaner)")
	p.add_option("--orgDirectory",  "-t",   dest="textDirNameW",            default="F:\\pubmed\\Stat\\", help="Absolute path of the directory where articles are stored (once processed with the cleaner)")
        p.add_option("--clnDirectory",  "-c",   dest="clnDirNameW",             default="F:\\Cleaned_Texts_STAT\\", help="Absolute path of the directory where cleaned articles, Rapid miner results... are stored")
        p.add_option("--srcDirectory",  "-s",   dest="srcDirNameW",             default="F:\\Text_Selection_STAT_ABBD\\", help="Absolute path of the directory where cleaned articles, Rapid miner results... are stored")
        p.add_option("--dstDirectory",  "-d",   dest="dstDirNameW",             default="F:\\Results", help="Absolute path of the directory where cleaned articles, Rapid miner results... are stored")
        p.add_option("--fnDirectory",   "-f",   dest="fnDirNameW", 		default="F:\\FileNumFiles_STAT\\", help="Absolute path of the directory where cleaned articles, Rapid miner results... are stored")
        p.add_option("--intDirectory",          dest="intermediateDirName",     default="Intermediate", help="Name of the directory where to store the intermediary processing files (Ex. data.dat)")
	p.add_option("--summFileName",		dest="summaryFileName",		default="Summary", help="Name of the summary file")
	p.add_option("--summSorted",		dest="summarySorted",		default="Summary_Sorted", help="Name of the summary file (the sorted one)")
	p.add_option("--hashfileName",		dest="hashFileName",		default="Hash_File.hashfile", help="Name of a file in which each line has two entries: the name of the selected file and the name of the weights")	
	p.add_option("--ratio",			dest="ratio",			default="20", help="Ratio of the original text included in summarization")
	p.add_option("--alfa",			dest="maxAlfa",			default="5.0", help="Value of the alfa parameter of the grading function")
	p.add_option("--beta",			dest="maxBeta",			default="1.0", help="Value of the beta parameter of the grading function")
	p.add_option("--gamma",			dest="maxGamma",		default="1.0", help="Value of the gamma parameter of the grading function")        
	p.add_option("--goldenGeneIDFile",	dest="goldenGeneIDFileW",      	default="GoldenGeneCounter_ID.txt", help="")
	p.add_option("--goldenOTSIDFile",	dest="goldenOTSIDFileW",      	default="Summary_Sorted_Id.txt", help="")
	p.add_option("--linux",                 dest="linuxOrNot",              default="linux", help="If not set -> working under Windows; if set to linux working under Linux")

        option, arguments = p.parse_args()

	if option.linuxOrNot == "linux" :
		workDirName = option.workDirNameW.replace("F:\\", "/media/DATI/")
		workDirName = workDirName.replace('\\', '/')
		goldDirName = option.goldDirNameW.replace("F:\\", "/media/DATI/")
		goldDirName = goldDirName.replace('\\', '/')
		textDirName = option.textDirNameW.replace("F:\\", "/media/DATI/")
		textDirName = textDirName.replace('\\', '/')
		clnDirName  = option.clnDirNameW.replace("F:\\", "/media/DATI/")
		clnDirName  = clnDirName.replace('\\', '/')
		srcDirName  = option.srcDirNameW.replace("F:\\", "/media/DATI/")
		srcDirName  = srcDirName.replace('\\', '/')		
		dstDirName  = option.dstDirNameW.replace("F:\\", "/media/DATI/")
		dstDirName  = dstDirName.replace('\\', '/')		
		fnDirName  = option.fnDirNameW.replace("F:\\", "/media/DATI/")
		fnDirName  = fnDirName.replace('\\', '/')		
		progPath = "python "+workDirName + os.sep		
	else :
		workDirName = option.workDirNameW
		textDirName = option.textDirNameW
		goldDirName = option.goldDirNameW
		clnDirName  = option.clnDirNameW
		srcDirName  = option.srcDirNameW
		dstDirName  = option.dstDirNameW
		fnDirName  = option.fnDirNameW
		progPath = workDirName + os.sep

	goldenGeneIDFile  = os.path.normpath(goldDirName+os.sep+option.intermediateDirName+os.sep+option.goldenGeneIDFileW)
	goldenOTSIDFile  =  os.path.normpath(goldDirName+os.sep+option.intermediateDirName+os.sep+option.goldenOTSIDFileW)
	ratio = float(option.ratio)

	# Retrieving the Ids of the GoldenGene Id
        fgg = open (goldenGeneIDFile, mode='r')
	goldenGeneID={} 
	goldenShareID={}
	tmpList = []
        sentencesGeneInID = 0
        for line in fgg :
		# Each row contains an Id only
                words = line.strip()
		tmpList.append(words)
		sentencesGeneInID+=1
        fgg.close()
	prese = 0
	maxSent = int((sentencesGeneInID*ratio)/100.0)
	for i in range(0, maxSent):
		words = tmpList[i]
		goldenGeneID[words] = ''
		prese+=1
	print "Stored the Id of Golden Gene; GoldenGene: ", sentencesGeneInID, " Taken: ", prese

	sentencesGeneInSumm = 0
	# Retrieving the Ids of the GoldenOTS Ids
        fgo = open (goldenOTSIDFile, mode='r')
	goldenOTSID ={}
	tmpListS = []        
        for line in fgo :
		# Each row contains an Id only
                words = line.strip()
		tmpListS.append(words)
		sentencesGeneInSumm +=1
        fgo.close()
	prese = 0
	comuni = 0
	maxSentS = int((sentencesGeneInSumm*ratio)/100.0)
	for i in range(0, maxSentS):
		words = tmpListS[i]
		goldenOTSID[words] = ''
		if goldenGeneID.has_key(words) :
			goldenShareID[words] = ''
			comuni +=1
		prese+=1
	print "Stored the Id of Golden Summ; GoldenSumm ", sentencesGeneInSumm, " Taken: ", prese
	print "Sentences common for the tw sets: ", comuni
	# Fill a dictionary with all the sentences and their characteristic value
	listNotSorted = []
	sentDict = {}
        for fileName in os.listdir(goldDirName) :
		if (fileName != option.intermediateDirName) :		
		
			source = os.path.normpath(goldDirName+os.sep+fileName)
			fr = open(source, 'r')
	
			sentence = ""
			for line in fr :
				if line.strip() == "------------------------------":
					continue
				if line.strip() == "" or line.strip() == " ":
					continue

				if (line.find("{{{") != -1) : 
					#found the last line
					values = line.strip().split("{{{")
					# in 0 I have the sentence; in 1 I have 'ID WC GENE BUCKET}}}'
					sentence += values[0].strip()
					insideBrackets = values[1].strip().split("}}}")
					fourNumbers = insideBrackets[0].strip().split(", ")
					sentId = fourNumbers[0].strip()
					sentWc = int(fourNumbers[1].strip())
					sentGene = int(fourNumbers[2].strip())
					sentBuck = int(fourNumbers[3].strip())				

					token = [sentence, sentId, sentWc, sentGene, sentBuck]
					listNotSorted.append(token)
					#print len(listToSort), " ", listToSort[len(listToSort)-1]
					sentDict[sentence] = len(listNotSorted)-1 

					sentence = ""
				else :
					sentence += line
			fr.close()
	print "Read the files in ", goldDirName, "; Hash table of sentences stored "

        fdef = open ("/media/DATI/Measures_Total.txt", mode='w')
	header = "Alfa\tBeta\tGamma\tRecall_Gene\tRecall_OTS\tRecall_Common\tTotal\tScore_Gene\tmin\tmax\tScore_OTS\tmin\tmax\n"
	fdef.write(header)
	fdef.close()
        fdefperc = open ("/media/DATI/Measures_Perc.txt", mode='w')
	header = "Alfa\tBeta\tGamma\tRecall_Gene\tRecall_OTS\tRecall_Common\tScore_Gene\tmin\tmax\tScore_OTS\tmin\tmax\n"
	fdefperc.write(header)
	fdefperc.close()

	
	maxAlfa= float(option.maxAlfa)
	maxBeta= float(option.maxBeta)
	alfa = 1.0
	beta = 0.1
	gamma = 0.0

	while (alfa <= maxAlfa):
		beta = 0.1
		while (beta <= maxBeta):
			gamma = 0.0	
			while (gamma <= beta):
				print
				print " --- Run Alfa = ",alfa, "; Beta = ",beta, "; Gamma = ", gamma, " --- "				
				if runCleaner(progPath, textDirName, clnDirName, option.linuxOrNot, alfa, beta, gamma) == 1 :
					return 1		
				print "Cleaner Done ::: ", 
				if runSelector(progPath,clnDirName,srcDirName,option.intermediateDirName,option.linuxOrNot, fnDirName) == 1 :
					return 1
				print "Selector Done"

				sumName = option.summaryFileName + "_"+ str(alfa)+"-"+str(beta)+"-"+str(gamma) + ".txt"
				sumSortedName = option.summarySorted + "_"+ str(alfa)+"-"+str(beta)+"-"+str(gamma) + ".txt"
				recallGoldenGene = [0]; recallOriginalOTS = [0]; recallCommon = [0]; scoreGene = [0]; scoreSumm = [0]; totalSentences = [0]; minGene = [0]; maxGene = [0]; minOTS = [0]; maxOTS = [0]

				if ( obtainSummary(srcDirName,option.intermediateDirName,option.hashFileName,sumName,sumSortedName,sentDict,listNotSorted,goldenGeneID,goldenOTSID,goldenShareID, recallGoldenGene, recallOriginalOTS, recallCommon, scoreGene, scoreSumm, totalSentences,option.ratio,minGene, maxGene, minOTS, maxOTS )) == 1:
					return 1
				print "Summarizer and Sorter Done"

				#Write The Output (Metric file)
				fdef = open ("/media/DATI/Measures_Total.txt", mode='a')
				fdef.write(str(alfa)+"\t"+str(beta)+"\t"+str(gamma)+"\t"+str(recallGoldenGene[0])+"\t\t"+str(recallOriginalOTS[0])+"\t\t"+str(recallCommon[0])+"\t\t"+str(totalSentences[0])+"\t"+str(scoreGene[0])+"\t\t"+str(minGene[0])+"\t"+str(maxGene[0])+"\t"+str(scoreSumm[0])+"\t\t"+str(minOTS[0])+"\t"+str(maxOTS[0])+"\n")		
				fdef.close()

				fdefperc = open ("/media/DATI/Measures_Perc.txt", mode='a')
				recall_gene_perc = (recallGoldenGene[0]*1.0)/totalSentences[0]
				recall_summ_perc = (recallOriginalOTS[0]*1.0)/totalSentences[0]
				recall_comm = (recallCommon[0]*1.0)/totalSentences[0]
				fdefperc.write(str(alfa)+"\t"+str(beta)+"\t"+str(gamma)+"\t"+'%.5f' % (recall_gene_perc)+"\t\t"+'%.5f' % (recall_summ_perc)+"\t\t"+'%.5f' % (recall_comm)+"\t\t"+str(scoreGene[0])+"\t\t"+str(minGene[0])+"\t"+str(maxGene[0])+"\t"+str(scoreSumm[0])+"\t\t"+str(minOTS[0])+"\t"+str(maxOTS[0])+"\n")
				fdefperc.close()
				
				#Save the all the data of the experiment in a folder
				outputDirName = dstDirName + "_"+ str(alfa)+"-"+str(beta)+"-"+str(gamma)
				move_data(outputDirName,clnDirName,srcDirName,fnDirName, sumName, sumSortedName ) 
				if gamma == 0:
					gamma = beta
				else :
					gamma = beta+0.1
			beta += 0.1
		alfa += 1.0

        return 0


def runCleaner(progPath, textDirName, clnDirName, linux, alfa, beta, gamma) :
                
        programName = "XML_Text_Cleaner.py"
        try:
		progPath += programName                                    
		arguments = "-s "+ textDirName + " -d " + clnDirName + " -l "+linux  + " --alfa "+ str(alfa) + " --beta "+ str(beta) + " --gamma "+ str(gamma) +" >> Cleaner.txt "
		commandLine = progPath + " " + arguments

		p = subprocess.Popen(commandLine , shell=True)
		p.wait()
		if p.returncode != 0:
			print " --- Progam '"+programName+"': Abnormal termination (code ", p.returncode, ") ---"
			return 1
		else:
			ok = 1
			#print " --- Progam '"+programName+"' returned (code ", p.returncode, ") ---"
			#print                                
                        
        except OSError, e:
                print "Execution failed:", e

	return 0

def runSelector(progPath, clnDirName, srcDirName, intermediateDirName, linux,fnDirName):

        programName = "Text_Selector.py"
        try:
                titl = abst = body = kywd = 0
                tOption = aOption = bOption = kOption =allOption = ""                        
                aOption = " --abstract Y"
		bOption = " --body Y"
                selSuffix = "abbd"                
     
		progPath += programName                 
		selOption = tOption + aOption + bOption + kOption + allOption
		arguments = "-s "+ clnDirName + " -d " + srcDirName + " -i " +intermediateDirName + selOption +" -l "+linux + " --fileNumDirectory "+ fnDirName +" >> Selector.txt "
		commandLine = progPath + " " + arguments
                        
		p = subprocess.Popen(commandLine , shell=True)
		p.wait()
		if p.returncode != 0:
			print " --- Progam '"+programName+"': Abnormal termination (code ", p.returncode, ") ---"
			return 1
		else:
			ok = 1
			#print " --- Progam '"+programName+"' returned (code ", p.returncode, ") ---"
			#print
       
        except OSError, e:
                print "Execution failed:", e

	return 0

def obtainSummary (srcDirName,intermediateDirName,hashFileName, sumName,sumSortedName,sentDict,listNotSorted,goldenGeneID,goldenOTSID,goldenShareID, recallGoldenGene, recallOriginalOTS, recallCommon, scoreGene, scoreSumm, totalSentences, ratio ,minGene, maxGene, minOTS, maxOTS):

	# Reading the file Hash_file.hashfile and creating a dictionary where the keys are the name of the texts files and the values 
	# are the names of the weight files.
	hashfilePath = os.path.normpath(srcDirName+os.sep+intermediateDirName+os.sep+hashFileName)
	fh = open(hashfilePath, 'r');
	fileWeightMatch = {}
	for line in fh :
		listPaht = line.strip().split()
		fileWeightMatch[listPaht[0]] = listPaht[1]
	fh.close()

	success = 0

	summaryFileTMP = os.path.normpath("/media/DATI/TMP_"+sumName) # File where the summary is stored
	summaryFile = os.path.normpath("/media/DATI/"+sumName) # File where the summary is stored
	globalList = [] #Contains all the sentences in the whole summary

	for fileName in os.listdir(srcDirName) :
		if (fileName != intermediateDirName) :		
			weightfile = ""
			weightfile = fileWeightMatch[fileName]
			filePath = os.path.normpath(srcDirName+os.sep+fileName)	# file to summarize
			if weightfile == "" :
				print "Error "+ filePath 
				return 1
			arguments = "--ratio "+ str(ratio) +" --weight "+weightfile+ " > "+ summaryFileTMP #The output is written in the tmp file
			commandLine = "ots "+ filePath + " " + arguments
		        p = subprocess.Popen(commandLine , shell=True)
		        p.wait()

			if p.returncode != 0:
				print " --- Abnormal termination (code ", p.returncode, ") ---"
				return 1
			else:
				success += 1

			fr = open(summaryFileTMP, 'r') #Open the tmp file to normalize the scores
			listSentencesInFile = []
			sentence = ""
			maxScore = 0
			for line in fr :
				if line.strip() == "" or line.strip() == " ":
					continue

				if (line.find("[[SCORE =") != -1) : #found the last line (End of Sentence)
					
					values = line.strip().split("[[SCORE = ")
					words = values[0].strip() # All the words before [[SCORE = 
					sentence += words
					values2 = values[1].strip().split("]]")

					score = int(values2[0])
					if score > maxScore:
						maxScore = score

					indexWC = values2[1].strip().find(" [[WRD_COUNT = ")+ 15
					wordCount = int(values2[1].strip()[indexWC:])

					token = [sentence, score, wordCount]
					listSentencesInFile.append(token)										
					sentence = ""
				else :
					sentence += line
			fr.close()

			fw = open(summaryFile, 'a') # Appen the sentences with the normalized scores in the file with the summary
			for i in range (0, len(listSentencesInFile)):
				if len(listSentencesInFile) <= 1:
					listSentencesInFile[i][1] = 0.0
					#print "Got One!!"
				else :
					listSentencesInFile[i][1] = (listSentencesInFile[i][1]*1.0)/maxScore
				fw.write(str(listSentencesInFile[i][0])+" [[SCORE="+str(listSentencesInFile[i][1])+"]] [[WRD_COUNT = "+str(listSentencesInFile[i][2])+"]]\n\n")
			fw.write("\n ------------------------------\n")
			fw.close()	
                        os.remove(summaryFileTMP)

			globalList.extend(listSentencesInFile) #In global list I have the sentences of all the summary
			del listSentencesInFile[0:]

	print " --- Summarized: Progam 'ots' returned code 0 (", success, " times) --- Writing the sorted summary"

	# All the files were summarized so the global list now contains all the sentences in the summary
	globalList.sort(myCompareFloatScore)
	
	sentRatio = float(ratio)

	fsorted = open("/media/DATI/"+sumSortedName, 'w')		
	maxSent = int((len(globalList)*sentRatio)/100.0) # Maximum number of sentence of the summary that I must take
	prese = 0
	minimumGene = 1000000
	minimumOTS = 1000000
	maximumGene = 0
	maximumOTS = 0
	for i in range(0, maxSent) :	
		sentence = globalList[i][0] 

		#Retrieve the sentence from the dictionary
		if sentence[0]==' ':
			index = sentDict[sentence[1:]]	
		else: 
			index = sentDict[sentence]			

		if ( goldenGeneID.has_key( str(listNotSorted[index][1]) ) ): #the sentence id is in the goldenGeneSummary
			recallGoldenGene[0] += 1
		if (  goldenOTSID.has_key( str(listNotSorted[index][1]) ) ): #the sentence id is in the goldenOTSSummary
			recallOriginalOTS[0] += 1
		if (  goldenShareID.has_key( str(listNotSorted[index][1]) ) ): #the sentence id is in the goldenOTSSummary
			recallCommon[0] += 1

		totalSentences[0]+=1

		gn = int(listNotSorted[index][3])
		otsb = int(listNotSorted[index][4])
		if gn < minimumGene:
			minimumGene = gn
		if gn > maximumGene :
			maximumGene = gn
		if otsb < minimumOTS:
			minimumOTS = otsb
		if otsb > maximumOTS :
			maximumOTS = otsb
		
		scoreGene[0] += gn
		scoreSumm[0] += otsb
		prese+=1
		fullSentence = str(globalList[i][0])+" [[SCORE="+str(globalList[i][1])+"]] [[WRD_COUNT = "+str(globalList[i][2])+"]]"
		fsorted.write(fullSentence+" {{{"+str(listNotSorted[index][1])+", "+str(listNotSorted[index][2]) +", "+str(listNotSorted[index][3])+", "+str(listNotSorted[index][4])+"}}}\n\n")

	minGene[0] = minimumGene
	maxGene[0] = maximumGene 
	minOTS[0] = minimumOTS
	maxOTS[0] = maximumOTS
	fsorted.close()			

	return 0


def move_data(outputDirName,clnDirName,srcDirName,fnDirName, sumName, sumSortedName):

	if (os.path.exists(outputDirName)) :
                print "The specified output directory already exists: can't over-write. Returning"
                os._exit(1)
        else :
                os.mkdir(outputDirName)
	#print 
	#print "--- Run over: ", 
	shutil.move(clnDirName,outputDirName+os.sep+clnDirName.replace("/media/DATI/",""))
	#print "Moved ", clnDirName,
	shutil.move(srcDirName,outputDirName+os.sep+srcDirName.replace("/media/DATI/",""))
	#print "; Moved ", srcDirName,
	shutil.move(fnDirName, outputDirName+os.sep+fnDirName.replace("/media/DATI/",""))
	#print "; Moved ", fnDirName,
	shutil.move("/media/DATI/"+sumName, outputDirName+os.sep+sumName)
	#print "; Moved ", "/media/DATI/", sumName,
	shutil.move("/media/DATI/"+sumSortedName, outputDirName+os.sep+sumSortedName)
	#print "; Moved ", "/media/DATI/", sumSortedName
	#print 

	return 


def myCompare(token1, token2):

	gene1 = int(token1[3])
	gene2 = int(token2[3])
	wc1 = int(token1[2])
	wc2 = int(token2[2])
	id1 = token1[1]
	id2 = token1[1]
	if cmp(gene2,gene1) != 0 :
		return cmp(gene2,gene1)
	if cmp(wc2,wc1) != 0 :
		return cmp(wc2,wc1)
	return cmp(id2,id1)

def myCompareSumm(token1, token2):

	score1 = int(token1[5])
	score2 = int(token2[5])
	return cmp(score2,score1)

def myCompareFloatScore(token1, token2):

	score1 = float(token1[1])
	score2 = float(token2[1])
	return cmp(score2,score1)



if __name__ == "__main__":
	# Someone is launching this directly
	ret = main()
	if ret == 1 :
		os._exit(1)
	os._exit(0)
