from xml.etree.ElementTree import ElementTree
from optparse import OptionParser
import os
import subprocess

def main():
        p = OptionParser()
	p.add_option("--sourceFileNameOTS", dest="srcOTS", default="F:\\@_Lorenzo\\@_Tesi\\Results\\Alfa_Beta_Gamma_Evaluation\\Golden\\Golden_Stat\\Summary_Sorted.txt", help="")
	p.add_option("--destFileNameOTS", dest="dstOTS", default="F:\\@_Lorenzo\\@_Tesi\\Results\\Alfa_Beta_Gamma_Evaluation\\Golden\\Golden_Stat\\Golden_OTS_Cumulative.txt", help="")
	p.add_option("--sourceFileNameGene", dest="srcGene", default="F:\\@_Lorenzo\\@_Tesi\\Results\\Alfa_Beta_Gamma_Evaluation\\Golden\\Golden_Stat\\GoldenGeneCounter.txt", help="")
        p.add_option("--destFileNameGene", dest="dstGene", default="F:\\@_Lorenzo\\@_Tesi\\Results\\Alfa_Beta_Gamma_Evaluation\\Golden\\Golden_Stat\\Golden_Gene_Cumulative.txt", help="")
	p.add_option("--linux", "-l", dest="linuxOrNot", default="linux", help="If not set -> working under Windows; if set to linux working under Linux")
	
        option, arguments = p.parse_args()

	if option.linuxOrNot == "linux" :
		srcOTS = option.srcOTS.replace('%20', ' ')
		srcOTS = srcOTS.replace("F:\\", "/media/DATI/")
		srcOTS = srcOTS.replace('\\', '/')
		dstOTS = option.dstOTS.replace('%20', ' ')
		dstOTS = dstOTS.replace("F:\\", "/media/DATI/")
		dstOTS = dstOTS.replace('\\', '/')
		srcGene = option.srcGene.replace('%20', ' ')
		srcGene = srcGene.replace("F:\\", "/media/DATI/")
		srcGene = srcGene.replace('\\', '/')
		dstGene = option.dstGene.replace('%20', ' ')
		dstGene = dstGene.replace("F:\\", "/media/DATI/")
		dstGene = dstGene.replace('\\', '/')
	else :
		srcOTS = option.srcOTS
		dstOTS = option.dstOTS
		srcGene = option.srcGene
		dstGene = option.dstGene

	frg = open(srcGene, 'r')
	fcg = open(dstGene, 'w')

	cumlativeNumber = 0
	numberSentences = 1
	for line in frg:

		if (line.find("{{{") != -1) : 
			#found the last line
			values = line.strip().split("{{{")
			# in 0 I have the sentence; in 1 I have 'ID WC GENE BUCKET}}}'
			insideBrackets = values[1].strip().split("}}}")
			fourNumbers = insideBrackets[0].strip().split(", ")
			sentId = fourNumbers[0].strip()
			sentWc = int(fourNumbers[1].strip())
			sentGene = int(fourNumbers[2].strip())
			cumlativeNumber += sentGene
			fcg.write(str(numberSentences)+ " "+str(cumlativeNumber) + "\n")
			print sentId, " ", 
			numberSentences+=1
	frg.close()
	fcg.close()
	print

	fro = open(srcOTS, 'r')
	fco = open(dstOTS, 'w')

	cumlativeNumberO = 0
	numberSentencesO = 1
	for line in fro:

		if (line.find("{{{") != -1) : 
			#found the last line
			values = line.strip().split("{{{")
			# in 0 I have the sentence; in 1 I have 'ID WC GENE BUCKET}}}'
			insideBrackets = values[1].strip().split("}}}")
			fourNumbers = insideBrackets[0].strip().split(", ")
			sentId = fourNumbers[0].strip()
			sentWc = int(fourNumbers[1].strip())
			sentGene = int(fourNumbers[2].strip())
			bucket = int(fourNumbers[3].strip())
			cumlativeNumberO += bucket
			fco.write(str(numberSentencesO)+ " "+str(cumlativeNumberO) + "\n")
			print sentId, " ", 
			numberSentencesO+=1
	fro.close()
	fco.close()
	print

	return

if __name__ == "__main__":
	# Someone is launching this directly
	main()
