from xml.etree.ElementTree import ElementTree
from optparse import OptionParser
import os

def main():
        p = OptionParser()
        p.add_option("--source", "-s", dest="sourceDictionaryNB", default="F:\\@_Lorenzo\\@_Tesi\\@_Framework_Parts\\en.xml", help="Absolute path where the original dictionary is stored")
        p.add_option("--name", "-n", dest="destDictionaryNB", default="F:\\@_Lorenzo\\@_Tesi\\@_Framework_Parts\\stopWords.txt", help="Name of the file where the stopwords are stored")
        p.add_option("--linux", "-l", dest="linuxOrNot", default="", help="If not set -> working under Windows; if set to linux working under Linux")
        option, arguments = p.parse_args()

        if option.linuxOrNot == "linux" :
                sourceDictionary = option.sourceDictionaryNB.replace('%20', ' ')
                sourceDictionary = sourceDictionary.replace("F:\\", "/media/DATI/")
                sourceDictionary = sourceDictionary.replace('\\', '/')                               
                destDictionary = option.destDictionaryNB.replace('%20', ' ')
                destDictionary = destDictionary.replace("F:\\", "/media/DATI/")
                destDictionary = destDictionary.replace('\\', '/')
        else :
                sourceDictionary = option.sourceDictionaryNB.replace('%20', ' ')
                destDictionary = option.destDictionaryNB.replace('%20', ' ')

        source = os.path.normpath(sourceDictionary)
        dest = os.path.normpath(destDictionary)
        
        parserFunction(source,dest)
        return

def parserFunction(sourceFile,destFile):
        
        tree = ElementTree()        
        try:
            tree.parse(sourceFile)
        except Exception, inst:
            print "Unexpected error opening %s: %s" % (sourceFile, inst)
            return

        f = open (destFile, mode='w')

        treeIterator = tree.getiterator()
        for  el in treeIterator:
                if el.tag == "word" :
                        text = el.text
                        f.write(text + "\n")
                        f.write(text.capitalize() + "\n")
        f.close()
        return                

if __name__ == "__main__":
	# Someone is launching this directly
	main()
