#!/usr/bin/pyhton2.5
from optparse import OptionParser
import os
import time
import subprocess


path = os.path.abspath('./BioSumm/')+os.sep


def main():
        p = OptionParser()

        p.add_option("--workDirectory", "-w",   dest="workDirNameW",            default= path+"@_Framework_Parts/", help="Absolute path of the directory pieces of the framework are stored")
##	p.add_option("--orgDirectory",  "-t",   dest="textDirNameW",            default="F:\\pubmed\\Articles%20Keywords\\", help="Absolute path of the directory where articles are stored (once processed with the cleaner)")
	p.add_option("--orgDirectory",  "-t",   dest="textDirNameW",            default="/home/gyros/Documenti/thesis/biosumm-0.3/temp/", help="Absolute path of the directory where articles are stored (once processed with the cleaner)")
##	p.add_option("--orgDirectory",  "-t",   dest="textDirNameW",            default="F:\\pubmed\\Breast%20Cancer%20Full\\", help="Absolute path of the directory where articles are stored (once processed with the cleaner)")
##	p.add_option("--orgDirectory",  "-t",   dest="textDirNameW",            default="F:\\pubmed\\Arthritis%20Res%20KWD\\", help="Absolute path of the directory where articles are stored (once processed with the cleaner)")
##	p.add_option("--orgDirectory",  "-t",   dest="textDirNameW",            default="F:\\pubmed\\Arthritis%20Res%20Full\\", help="Absolute path of the directory where articles are stored (once processed with the cleaner)")
##	p.add_option("--orgDirectory",  "-t",   dest="textDirNameW",            default="F:\\pubmed\\BMC%20Bioinformatics\\", help="Absolute path of the directory where articles are stored (once processed with the cleaner)")
##	p.add_option("--orgDirectory",  "-t",   dest="textDirNameW",            default="F:\\pubmed\\Bioinformation\\", help="Absolute path of the directory where articles are stored (once processed with the cleaner)")
##	p.add_option("--orgDirectory",  "-t",   dest="textDirNameW",            default="F:\\pubmed\\Crit%20Care\\", help="Absolute path of the directory where articles are stored (once processed with the cleaner)")
##	p.add_option("--orgDirectory",  "-t",   dest="textDirNameW",            default="F:\\pubmed\\Crit%20Care_Source\\", help="Absolute path of the directory where articles are stored (once processed with the cleaner)")
##	p.add_option("--orgDirectory",  "-t",   dest="textDirNameW",            default="F:\\pubmed\\Crit%20Care_Backup\\", help="Absolute path of the directory where articles are stored (once processed with the cleaner)")
##	p.add_option("--orgDirectory",  "-t",   dest="textDirNameW",            default="F:\\pubmed\\Jews\\", help="Absolute path of the directory where articles are stored (once processed with the cleaner)")
##	p.add_option("--orgDirectory",  "-t",   dest="textDirNameW",            default="F:\\pubmed\\Vaccin\\", help="Absolute path of the directory where articles are stored (once processed with the cleaner)")
##	p.add_option("--orgDirectory",  "-t",   dest="textDirNameW",            default="F:\\pubmed\\Osteoclast\\", help="Absolute path of the directory where articles are stored (once processed with the cleaner)")
##	p.add_option("--orgDirectory",  "-t",   dest="textDirNameW",            default="F:\\pubmed\\Stat\\", help="Absolute path of the directory where articles are stored (once processed with the cleaner)")
        p.add_option("--clnDirectory",  "-c",   dest="clnDirNameW",             default=path+"Cleaned_Texts_BC/", help="Absolute path of the directory where cleaned articles, Rapid miner results... are stored")
        p.add_option("--srcDirectory",  "-s",   dest="srcDirNameW",             default=path+"Text_Selection_BC_ABBD/", help="Absolute path of the directory where cleaned articles, Rapid miner results... are stored")
        p.add_option("--dstDirectory",  "-d",   dest="destDirNameW",            default=path+"Experimental_Results_BC/", help="Absolute path of the directory where cleaned articles, Rapid miner results... are stored")
        p.add_option("--copyDirectory",         dest="copyDirNameW",            default=path+"pubmed/prova2/", help="Absolute path of the directory where to copy the articles with keywords if needed")
	p.add_option("--fileNumDirectory", 	dest="fileNumDirnameW", 	default=path+"FileNumFiles_BC/", help="Absolute path of the directory where the files NUM and DUP containing number of distinct and duplicated genes are stored")
        p.add_option("--intDirectory",          dest="intermediateDirName",     default="Intermediate", help="Name of the directory where to store the intermediary processing files (Ex. data.dat)")
        p.add_option("--dictionary",            dest="dictionaryFileNameW",     default=path+"@_Framework_Parts/Dictionary_and_Stopwords/gene_dictionary.txt", help="Absolute path of the file with the genes and proteins dictionary")
	p.add_option("--dictionaryID",		dest="dictionaryIDFileNameW",	default=path+"@_Framework_Parts/Frequent_Itemsets/gene_dictionary_ID.txt", help="Absolute path of the file with the genes and proteins dictionary with an ID (used for itemsets)")
        p.add_option("--stopDictionary",        dest="stopWordsFileNameW",      default=path+"@_Framework_Parts/Dictionary_and_Stopwords/stopWords.txt", help="Absolute path of the file with the stopwords dictionary")
	p.add_option("--transaction",		dest="transactionW",      	default=path+"Transactions/Transact.txt", help="Absolute path of the file with the trasactions of the summary files")
	p.add_option("--transactionSumm",	dest="transactionSummW",      	default=path+"Transactions/Transact_Summ.txt", help="Absolute path of the file with the trasactions of the summary files")
	p.add_option("--statistics",            dest="statFileNameW",           default="Text_Statistics.txt", help="Absolute path of the file where the final statistics ( of XML cleaner) are stored")        
	p.add_option("--gnFoundFileName",	dest="gnFoundFileName",		default="DocGenes.txt", help="Absolute path of the file where all the files wih genes (and the corresponding number of genes) are stored")
        p.add_option("--suffix",                dest="suffix",                  default="clean", help="Suffix to be added to the processed article name")
        p.add_option("--wSuffix",               dest="wSuffix",                 default="W_FN", help="Suffix to be added to the processed article name (weight file)")
	p.add_option("--summarySuffix",         dest="summarySuffix",           default="summ", help="Suffix to be added to the summary files (in the summarizer used for itemsets)")
	p.add_option("--scoreSummSuffix", 	dest="scoreSummSuffix", 	default="Scores", help="Suffix to be added to the summary files sorted and not sorted when they also report scores")
        p.add_option("--xmlName",               dest="xmlProcessFileName",      default="Preprocessor.xml", help="Name of the xml process source to be processed")
        p.add_option("--attFileName",           dest="attrFileName",            default="attribute.aml", help="Name of the file where Rapid Miner must store the attributes")
        p.add_option("--dataFileName",          dest="dataFileName",            default="data.dat", help="Name of the file where Rapid Miner must store the data")
        p.add_option("--programCluster",        dest="clusterProgram",          default="vcluster", help="Name of the cluto executable used to do the clustering")
        p.add_option("--clusterNumber",         dest="clusterNumber",           default="1", help="Number of clusters that cluto is supposed to produce")
        p.add_option("--outputCluto",           dest="outputClutoFileName",     default="CLUTO_results.dat", help="Name of the file in which the results of CLUTo measures ar stored")
	p.add_option("--hashfileName",		dest="hashFileName",		default="Hash_File.hashfile", help="Name of a file in which each line has two entries: the name of the selected file and the name of the weights")	
        p.add_option("--rowLabel",              dest="rowLabelFileName",        default="RowLabels.rlabel", help="Name of the file in which the labels of the rows of the matrix generated by RM are stored")
        p.add_option("--colLabel",              dest="colLabelFileName",        default="ColLabels.clabel", help="Name of the file in which the labels of the columns of the matrix generated by RM are stored")        
	p.add_option("--gifPlot",               dest="plotFileName",            default="Cluster.gif", help="Name of the file where the plot drawn by CLUTO is stored")
	p.add_option("--copyArticles",          dest="copyArticles",            default="N", help="Says whether to copy the articles with keywords in a specified directory")
	p.add_option("--title",                 dest="titleOrNot",              default="", help="If not set ('') the title must not be taken; if set to 'Y' grab the title")
        p.add_option("--abstract",              dest="abstractOrNot",           default="Y", help="If not set ('') the abstract must not be taken; if set to 'Y' grab the abstract")
        p.add_option("--body",                  dest="bodyOrNot",               default="Y", help="If not set ('') the body must not be taken; if set to 'Y' grab the body")
        p.add_option("--kwd",                   dest="kwdOrNot",                default="", help="If not set ('') the keywords must not be taken; if set to 'Y' grab the keywords")        
        p.add_option("--all",                   dest="allOrNot",                default="", help="If set to 'Y' the whole text must be taken")
        p.add_option("--runCleaner",            dest="runCleaner",              default="Y", help="If not set -> don't run XML_Text_Cleaner.py; if set to 'Y' run it")
        p.add_option("--runSelector",           dest="runSelector",             default="Y", help="If not set -> don't run Text_Selector.py; if set to 'Y' run it")
        p.add_option("--runRapidminer",         dest="runRapidminer",           default="Y", help="If not set -> don't run rapidminer; if set to 'Y' run it")
        p.add_option("--runCopier",             dest="runCopier",               default="Y", help="If not set -> don't run Text_Copier.py; if set to 'Y' run it")
        p.add_option("--RMManager",             dest="RMManager",               default="copy", help="If not set -> what in srcDirName\Intermediated\ will be used; if set to 'copy' what in destDirName will be used by cluto; if set to 'N' nothing will be done")
        p.add_option("--runCluto",              dest="runCluto",                default="Y", help="If not set -> don't run Cluto; if set to 'Y' run it")
        p.add_option("--runOrganizer",          dest="runOrganizer",            default="Y", help="If not set -> don't run Result_organizer.py; if set to 'Y' run it")
        p.add_option("--runSummarizer",         dest="runSummarizer",           default="Y", help="If not set -> don't run Summarizer.py; if set to 'Y' run it")
	p.add_option("--itemset",		dest="itemset",			default="N", help="If not set -> the framework must not evaluate the itemsets; if set to 'Y' it must")
	p.add_option("--summFileName",		dest="summaryFileName",		default="Summary.txt", help="Name of the summary file")
	p.add_option("--summSorted",		dest="summarySorted",		default="Summary_Sorted.txt", help="Name of the summary file (the sorted one)")
	p.add_option("--perfFileName",		dest="perfFileName",		default=path+"DATI/Performances_BC_ABBD.txt", help="Name of the summary file")
	p.add_option("--cluPerFileName",	dest="cluPerFileName",		default=path+"DATI/Cluster_BC_ABBD.txt", help="Name of the summary file")
	p.add_option("--summPerFileName",	dest="summPerFileName",		default=path+"DATI/Summ_BC_ABBD.txt", help="Name of the summary file")
	p.add_option("--ratio",			dest="ratio",			default="20", help="Ratio of the original text included in summarization")
	p.add_option("--alfa",			dest="alfa",			default="2.0", help="Value of the alfa parameter of the grading function")
	p.add_option("--beta",			dest="beta",			default="0.1", help="Value of the beta parameter of the grading function")
	p.add_option("--gamma",			dest="gamma",			default="0.1", help="Value of the gamma parameter of the grading function")        
	p.add_option("--score", 		dest="scoreOrNot", 		default="Y", help="If set to 'Y' two more files (sorted and not sorted) with also the scores for each sentences will be produced; If not set these two files won't be produced")
        p.add_option("--numberAndDuplicates",	dest="numAndDupOrNot",		default="N", help="If set to Y the files NUM and DUP with the number of distinct and duplicated genes will be produced. If not set nothing will be done")
	p.add_option("--linux",                 dest="linuxOrNot",              default="linux", help="If not set -> working under Windows; if set to linux working under Linux")

        option, arguments = p.parse_args()

	if option.linuxOrNot == "linux" :
		workDirName = option.workDirNameW.replace("F:\\", "/media/DATI/")
		workDirName = workDirName.replace('\\', '/')
		textDirName = option.textDirNameW.replace("F:\\", "/media/DATI/")
		textDirName = textDirName.replace('\\', '/')
		destDirName = option.destDirNameW.replace("F:\\", "/media/DATI/")
		destDirName = destDirName.replace('\\', '/')
		newDestDirName = destDirName
		copyDirName = option.copyDirNameW.replace("F:\\", "/media/DATI/")
		copyDirName = copyDirName.replace('\\', '/')
		fileNumDirname = option.fileNumDirnameW.replace("F:\\", "/media/DATI/")
		fileNumDirname = fileNumDirname.replace('\\', '/')
		clnDirName  = option.clnDirNameW.replace("F:\\", "/media/DATI/")
		clnDirName  = clnDirName.replace('\\', '/')
		srcDirName  = option.srcDirNameW.replace("F:\\", "/media/DATI/")
		srcDirName  = srcDirName.replace('\\', '/')
		dictionaryFileName  = option.dictionaryFileNameW.replace("F:\\", "/media/DATI/")
		dictionaryFileName  = dictionaryFileName.replace('\\', '/')
		dictionaryIDFileName  = option.dictionaryIDFileNameW.replace("F:\\", "/media/DATI/")
		dictionaryIDFileName  = dictionaryIDFileName.replace('\\', '/')
		stopWordsFileName  = option.stopWordsFileNameW.replace("F:\\", "/media/DATI/")
		stopWordsFileName  = stopWordsFileName.replace('\\', '/')
		transactionSumm  = option.transactionSummW.replace("F:\\", "/media/DATI/")
		transactionSumm  = transactionSumm.replace('\\', '/')
		transaction  = option.transactionW.replace("F:\\", "/media/DATI/")
		transaction  = transaction.replace('\\', '/')
		statFileName  = option.statFileNameW.replace("F:\\", "/media/DATI/")
		statFileName  = statFileName.replace('\\', '/')
		
	else :
		workDirName = option.workDirNameW
		textDirName = option.textDirNameW
		destDirName = option.destDirNameW
		copyDirName = option.copyDirNameW
		fileNumDirname = option.fileNumDirnameW
		clnDirName  = option.clnDirNameW
		srcDirName  = option.srcDirNameW
		dictionaryFileName  = option.dictionaryFileNameW
		dictionaryIDFileName  = option.dictionaryIDFileNameW
		stopWordsFileName  = option.stopWordsFileNameW
		transactionSumm  = option.transactionSummW
		transaction  = option.transactionW
		statFileName  = option.statFileNameW
		newDestDirName = destDirName

	print "Working directory (containing parts of the framework): "
	print " - " + workDirName
	print "Text directory (containing the original source texts in XML format): "
	print " - "+textDirName
	print "Cleaned texts directory (containing the cleaned source texts with only the needed XML tags): "
	print " - "+clnDirName
        print "Source directory (containing the desired selection of the cleaned texts): "
	print " - "+srcDirName
	print "Output directory"
	print " - "+destDirName
	print "Number of clusters: ", option.clusterNumber
	print


	fperf = open (option.perfFileName, mode='a')
	fclu =  open (option.cluPerFileName, mode='a')
	fsumm =  open (option.summPerFileName, mode='a')
	
	globalStartTime = time.time()
	startTimeCleaner = globalStartTime

	if option.itemset == "Y":
	        if (os.path.exists("/media/DATI/Transactions/") == False) :
	                os.mkdir("/media/DATI/Transactions/")
	
	f=open(path+'status.txt','w')	
	f.write('1/11. XML Text Cleaner')
	f.close()
	programName = "XML_Text_Cleaner.py"
        print "  ******** Executing "+ programName +" ********"
        print
        try:
                # This script will take the XML sources stored in textDirName and it will extract from them only the needed information.
                # It will produce an output in a simplified XML format with the tags, article, title, abstract, body, keywords and weights.
                # The weights are a multiplicative factor associated to each sentence and related to the presence of the genes contained in
                # the dictionary.
                if option.runCleaner == "Y" or option.itemset == "Y":
			if (option.itemset == "Y") :
				programName = "XML_Text_Cleaner_Freq_Itemset.py"
		                if option.linuxOrNot == "linux" :
		                        progPath = "python "+workDirName+os.sep+"Frequent_Itemsets"+ os.sep + programName
		                else : 
		                        progPath = workDirName + os.sep + programName
		                                      
		                arguments = "-s "+ textDirName + " -d " + clnDirName + " --transaction "+ transaction +" -v "+ dictionaryIDFileName+ " -p " + stopWordsFileName + " -t " + statFileName + " -n " + option.suffix + " --gnFoundFileName "+ option.gnFoundFileName+" -l "+option.linuxOrNot + " --copyArticles " +option.copyArticles + " --copyDirectory " + copyDirName + " --alfa "+ option.alfa + " --beta "+ option.beta + " --gamma "+ option.gamma	
		                commandLine = progPath + " " + arguments
		                p = subprocess.Popen(commandLine , shell=True)
		                p.wait()
		                if p.returncode != 0:
		                        print " --- Progam '"+programName+"': Abnormal termination (code ", p.returncode, ") ---"
					return 1
		                else:
		                        print " --- Progam '"+programName+"' returned (code ", p.returncode, ") ---"
		                        print

			else :
				if option.linuxOrNot == "linux" :
	                                progPath = "python "+workDirName + os.sep + programName
	                        else : 
	                                progPath = workDirName + os.sep + programName
                                              
	                        arguments = "-s "+ textDirName + " -d " + clnDirName + " -v "+ dictionaryFileName+ " -p " + stopWordsFileName + " -t " + statFileName + " -n " + option.suffix + " --gnFoundFileName "+ option.gnFoundFileName+" -l "+option.linuxOrNot + " --copyArticles " +option.copyArticles + " --copyDirectory " + copyDirName + " --alfa "+ option.alfa + " --beta "+ option.beta + " --gamma "+ option.gamma + " --numberAndDuplicates "+ option.numAndDupOrNot	
	                        commandLine = progPath + " " + arguments
	                        p = subprocess.Popen(commandLine , shell=True)
	                        p.wait()
	                        if p.returncode != 0:
	                                print " --- Progam '"+programName+"': Abnormal termination (code ", p.returncode, ") ---"
					return 1
	                        else:
	                                print " --- Progam '"+programName+"' returned (code ", p.returncode, ") ---"
	                                print
                                
                else :
                        print "The user decided to avoid running XML_Text_Cleaner."
                        print "The program will run using what stored in ", clnDirName
                        print
                        
        except OSError, e:
                print "Execution failed:", e

	endTimeCleaner = time.time()
	# Write in the performance file the time elapsed executing this module and the incremental tie from the beginning
	fperf.write (str(endTimeCleaner- startTimeCleaner) + "\t" + str(endTimeCleaner- globalStartTime ) + "\t")

	startTimeSel = time.time()

	f=open(path + 'status.txt','w')
	f.write('2/11. Text Selector')
	f.close()
        programName = "Text_Selector.py"
        print "  ******** Executing "+ programName +" ********"
        print
        try:
                # Decide which part of the text must be selected (or was selected by previous experiments)
                # I need to know in any case (both running or not running the script) the suffix of the
                # weight file. If the script will be run it will create weight files which such suffix;
                # otherwise the other scripts will anyway know which suffix to use.
                titl = abst = body = kywd = 0
                tOption = aOption = bOption = kOption =allOption = ""                        
                if (option.titleOrNot == "Y") :
                        titl = 1
                        tOption = "--title Y"
                        selSuffix = "tit"
                if (option.abstractOrNot == "Y") :
                        abst = 1
                        aOption = " --abstract Y"
                        if titl == 1 :
                                selSuffix += "ab"
                        else :
                                selSuffix = "ab"                
                if (option.bodyOrNot == "Y") :
                        body = 1
                        bOption = " --body Y"
                        if (titl == 1 or abst == 1) :
                                selSuffix += "bd"
                        else :
                                selSuffix = "bd"
                if (option.kwdOrNot == "Y") :
                        kywd = 1
                        kOption = " --kwd Y"
                        if (titl == 1 or abst == 1 or body == 1) :
                                selSuffix += "k"
                        else :
                                selSuffix = "k"
                                
                if option.allOrNot == "Y" :
                        allOption = " --all Y"
                        selSuffix = "all"
                                
                if option.runSelector == "Y" or option.itemset == "Y":
                        # The script must be executed: it will create the directory srcDirName that can the basis of many
                        # experiments                        
                        if option.linuxOrNot == "linux" :
                                progPath = "python "+workDirName + os.sep + programName
                        else : 
                                progPath = workDirName + os.sep + programName

                        selOption = tOption + aOption + bOption + kOption + allOption
                        arguments = "-s "+ clnDirName + " -d " + srcDirName + " -i " +option.intermediateDirName + " -n " + option.wSuffix + " " + selOption + " --hashfileName "+option.hashFileName+" --statistics " + statFileName + " --gnFoundFileName "+ option.gnFoundFileName+" --fileNumDirectory "+fileNumDirname+" --numberAndDuplicates "+option.numAndDupOrNot+" -l "+option.linuxOrNot                
                        commandLine = progPath + " " + arguments
                        
                        # The script will read every text in the directory clnDirName where the cleaned texts are placed by the XML_Cleaner
                        # The seleceted portions of the texts will be placed in the directory srcDirName (I don't put them directly in the
                        # output directory so that they can serve as input of multiple experiments)
                        p = subprocess.Popen(commandLine , shell=True)
                        p.wait()
                        if p.returncode != 0:
                                print " --- Progam '"+programName+"': Abnormal termination (code ", p.returncode, ") ---"
				return 1
                        else:
                                print " --- Progam '"+programName+"' returned (code ", p.returncode, ") ---"
                                print

                else :
                        print "The user decided to avoid running Text_Selector."
                        print "The program will run using what stored in ", srcDirName
                        print "The program will look for weight files with suffix ", selSuffix, " stored in the directory ", clnDirName
                        print
                        
        except OSError, e:
                print "Execution failed:", e

	endTimeSel = time.time()
	# Write in the performance file the time elapsed executing this module and the incremental tie from the beginning
	fperf.write (str(endTimeSel- startTimeSel) + "\t" + str(endTimeSel- globalStartTime ) + "\t")


	startTimeCop = time.time()
	
	f=open(path+'status.txt','w')	
	f.write('3/11. Text Copier')
	f.close()
        programName = "Text_Copier.py"
        print "  ******** Executing "+ programName +" ********"
        print
        try:
                # This script will copy the content of src directory to the output directory (Experimental_results).
                # In case Text_Selector.py was run it will copy simply the texts; if Text_Selector.py was not run
                # in the src directory there will be other files (produced by Rapidminer); these files will be copied
                # too so that the experiment will run without calling Rapidminer.
                # If the output directory specified on the command line (Ex. Experimental_Results) it WON'T be overwritten.
                # The directory <name>_i will be created and the texts will be copied there. The name of this directory
                # will be stored in a temporary file (tmp.txt) stored in the working directory (the one with the frameowork)
                # parts. The final part of the script will read this file fetch the name of the directory and store it in the
                # variable newDestDirName.
		if option.runCopier == "Y" :
                                
                        if option.linuxOrNot == "linux" :
                                progPath = "python "+workDirName + os.sep + programName
                        else : 
                                progPath = workDirName + os.sep + programName


                        selOption = tOption + aOption + bOption + allOption
                        
                        arguments = "-w "+workDirName + " -s "+ srcDirName + " -d " + destDirName + " -i " +option.intermediateDirName +" -l "+option.linuxOrNot
                        
                        commandLine = progPath + " " + arguments
                        p = subprocess.Popen(commandLine , shell=True)
                        p.wait()
                        if p.returncode != 0:
                                print " --- Progam '"+programName+"': Abnormal termination (code ", p.returncode, ") ---"
				return 1
                        else:
                                print " --- Progam '"+programName+"' returned (code ", p.returncode, ") ---"
                                print
                                
                                tmpFileName = workDirName + os.sep + "tmp.txt"
                                f = open (tmpFileName, mode='r')
                                newDestDirName = f.readline() # Name of the output directory of this experiment (Ex. Experimental_Results, Experimental_Results_1)
                                f.close()
                                os.remove(tmpFileName) # Deleting the temp file
                else :
                        print "Text_Copier.py Not run"
                        print
                        
        except OSError, e:
                print "Execution failed:", e


	endTimeCop = time.time()
	# Write in the performance file the time elapsed executing this module and the incremental tie from the beginning
	fperf.write (str(endTimeCop- startTimeCop) + "\t" + str(endTimeCop- globalStartTime ) + "\t")

	startTimeRM = time.time()
        
        print
        print "  ******** End of "+ programName +" ********"
        print
        
        
        f=open(path+'status.txt','w')	
	f.write('4/11. Process XML file for Rapid Miner')
	f.close()
        
        programName = "XML_Process_file_RM.py"
        print "  ******** Executing "+ programName +" ********"
        print       

        try:
                # This script modifies the XML file Preprocessor.xml stored in the working directory (the one where the framework parts are).
                # This XML file is the only input required by Rapidminer. The script will be run if Text_Selector.py was run or if the user
                # specified on the command line that he wants Rapidminer to be executed in any case

                if (option.runSelector == "Y" or option.runRapidminer == "Y") and option.itemset != "Y":
                        if option.linuxOrNot == "linux" :                
                                progPath = "python "+workDirName + os.sep + programName
                        else : 
                                progPath = workDirName + os.sep + programName
                        # The -p option requires the working directory (the one where the framework parts are stored)
                        # The -t option requires the directory where the texts that must be processed by rapid miner are stored
                        #       (it's the newDestDirName where the copier put the files)
                        # The -d option requires the results of the experiments are supposed to be stored
                        #       (it's the newDestDirName that is the one where CLUTO wants its inputs)
                        arguments = "-p "+ workDirName + " -n " + option.xmlProcessFileName + " -s " + option.suffix + " -t " + newDestDirName + " -d " + newDestDirName + " -a " +option.attrFileName+ " -f " + option.dataFileName
                        commandLine = progPath + " " + arguments			
			p = subprocess.Popen(commandLine , shell=True)                        
                        p.wait()
                        if p.returncode != 0:
                                print " --- Progam '"+programName+"': Abnormal termination (code ", p.returncode, ") ---"
				return 1
                        else:
                                print " --- Progam '"+programName+"' returned (code ", p.returncode, ") ---"
                                print
                else :
                        print "The user decided to avoid running XML_Process_file_RM.py."
                        print "The program will run using what stored in ", option.xmlProcessFileName
                        print
                        
        except OSError, e:
                print "Execution failed:", e

        print
        print "  ******** End of "+ programName +" ********"
        print
	
	f=open(path+'status.txt','w')	
	f.write('5/11. Executing RapidMiner')
	f.close()
	
	if option.linuxOrNot == "linux" :                
        	programName = "rapidminer"
	else :
		programName = "rapidminer.bat"	
        print "  ******** Executing "+ programName +" ********"
        print
        try:
                # This part of the code will run Rapidminer and it will get data.dat and attribute.aml.
                # Rapidminer will be run if the Text_selector.py was run or if the user explicitly decided to
                # run it by setting to Y the option runRapidminer.
                if (option.runSelector == "Y" and option.runRapidminer != "N") and option.itemset != "Y":
                        
                        progPath = programName
                        ext = os.path.splitext( option.xmlProcessFileName )
                        xmlProcessFileNameCleaned = ext[0].replace(' ','_') +"_"+option.suffix + ext[1]
                        arguments = workDirName + os.sep + xmlProcessFileNameCleaned
                        commandLine = progPath + " " + arguments
			#print 'RM CL: ', commandLine
			# The output of rapidminer is redirected to a file that is then immediately deleted
                        f = open ("RM_TMP.txt", mode='w')
                        p = subprocess.Popen(commandLine, stdout = f, shell=True)
                        p.wait()
                        #p = subprocess.Popen(commandLine, stdout = f, shell=True)
                        #p.wait()
                        f.close()
			#os.remove("RM_TMP.txt") # Deleting the temp file
                        
                        if p.returncode != 0:
                                print " --- Progam '"+programName+"': Abnormal termination (code ", p.returncode, ") ---"
				return 1
                        else:
                                print " --- Progam '"+programName+"' returned (code ", p.returncode, ") ---"
                                print
                else :
                        print "The user decided to avoid running Rapidminer."
                        printName = srcDirName+os.sep+option.intermediateDirName+os.sep
                        print "The program will run using what stored in ", printName
                        print
                        
        except OSError, e:
                print "Execution failed:", e

	#time.sleep(20)
	endTimeRM = time.time()
	# Write in the performance file the time elapsed executing this module and the incremental tie from the beginning
	fperf.write (str(endTimeRM- startTimeRM) + "\t" + str(endTimeRM- globalStartTime ) + "\t")

	startTimeConv = time.time()
        print
        print "  ******** End of "+ programName +" ********"
        print

	
	f=open(path+'status.txt','w')	
	f.write('6/11. Getting column labels')
	f.close()

        programName = "Column_Labels_Getter.py"
        print "  ******** Executing "+ programName +" ********"
        print

        try:
                # This script will process attribute.aml and will write in colLabelFileName the labels of the
                # columns of the matrix (the features).
                # It will be run if the Text_selector.py was run or if the user explicitly decided to
                # run it by setting to Y the option runRapidminer. It will be executed only when rapidminer was
                # executed. When rapidminer was not executed the file colLabelFileName stored in srcDirectory/Intermediate/
                # (old one) will be used.
                if (option.runSelector == "Y" and option.runRapidminer != "N") and option.itemset != "Y":
                        if option.linuxOrNot == "linux" :                
                                progPath = "python "+workDirName + os.sep + programName
                        else :
                                progPath = workDirName + os.sep + programName
                        arguments = "-w "+ newDestDirName + " -a " + option.attrFileName + " -n " + option.colLabelFileName 
                        commandLine = progPath + " " + arguments
                        p = subprocess.Popen(commandLine , shell=True)
                        p.wait()
                        if p.returncode != 0:
                                print " --- Progam '"+programName+"': Abnormal termination (code ", p.returncode, ") ---"
				return 1
                        else:
                                print " --- Progam '"+programName+"' returned (code ", p.returncode, ") ---"
                                print
                else:
                        print "The user decided to avoid running Column_Labels_Getter.py and Rapidminer."
                        printName = srcDirName+os.sep+option.intermediateDirName+os.sep
                        print "The program will run using what stored in ", printName
                        print
                        
        except OSError, e:
                print "Execution failed:", e

        print
        print "  ******** End of "+ programName +" ********"
        print
        
        
        f=open(path+'status.txt','w')	
	f.write('7/11. Converting from Rapid Miner output to CLUTO')
	f.close()
        
        programName = "Converter_RM_to_CLUTO.py"
        print "  ******** Executing "+ programName +" ********"
        print

        try:
                # This script will process data.dat and will write data_<suffix>.dat (a new file compliant with cluto
                # specifications and so with a first header line and without the 'row name' column) and in rowLabelFileName
                # the labels of the rows of the matrix (the name of the text files).
                # It will be run if the Text_selector.py was run or if the user explicitly decided to
                # run it by setting to Y the option runRapidminer. It will be executed only when rapidminer was
                # executed. When rapidminer was not executed the file data_<suffix>.dat and rowLabelFileName
                # stored in srcDirectory/Intermediate/ (old one) will be used.
                if (option.runSelector == "Y" and option.runRapidminer != "N") and option.itemset != "Y":

                        if option.linuxOrNot == "linux" :                                
                                progPath = "python " + workDirName + os.sep + programName
                        else : 
                                progPath = workDirName + os.sep + programName
                        arguments = "-p "+ newDestDirName + " -n " + option.dataFileName + " -s " + option.suffix  + " -r " + option.rowLabelFileName 
                        commandLine = progPath + " " + arguments
                        p = subprocess.Popen(commandLine , shell=True)
                        p.wait()
                        if p.returncode != 0:
                                print " --- Progam '"+programName+"': Abnormal termination (code ", p.returncode, ") ---"
				return 1
                        else:
                                print " --- Progam '"+programName+"' returned (code ", p.returncode, ") ---"
                                print

                else:
                        print "The user decided to avoid running Converter_RM_to_CLUTO.py and Rapidminer."
                        printName = srcDirName+os.sep+option.intermediateDirName+os.sep
                        print "The program will run using what stored in ", printName
                        print

        except OSError, e:
                print "Execution failed:", e

	endTimeConv = time.time()
	# Write in the performance file the time elapsed executing this module and the incremental tie from the beginning
	fperf.write (str(endTimeConv- startTimeConv) + "\t" + str(endTimeConv- globalStartTime ) + "\t")

	startTimeRMMan = time.time()

        print
        print "  ******** End of "+ programName +" ********"
        print
        
        
        f=open(path+'status.txt','w')	
	f.write('8/11. Converting Rapid Miner Output')
	f.close()
        
        programName = "RM_Output_Manager.py"
        print "  ******** Executing "+ programName +" ********"
        print

        try:
                # This script will place the input files required by cluto (data_<suffix>.dat rowLabelFileName, colLabelFileName)
                # into the output directory. If the option --RMManager will be 'copy' the newDestDir already contains the output
                # of rapidminer. It will be copied into srcDir to be used in next experiments. Othewise the content of
                # srcDir\Intermediate\ will be put into newDestDir (and so the old files will be used).
                if (option.RMManager != "N" ):                        
                        if option.linuxOrNot == "linux" :                                
                                progPath = "python " + workDirName + os.sep + programName
                        else : 
                                progPath = workDirName + os.sep + programName
                        arguments = "--RMManager "+ option.RMManager + " -s " + srcDirName + " -d "+ newDestDirName + " -i " +option.intermediateDirName + " -n " + option.suffix  + " -r " + option.rowLabelFileName + " -c " + option.colLabelFileName + " -a "+ option.attrFileName + " -f "+ option.dataFileName + " --hashfileName "+option.hashFileName + " -l "+option.linuxOrNot
                        commandLine = progPath + " " + arguments
                        p = subprocess.Popen(commandLine , shell=True)
                        p.wait()
                        if p.returncode != 0:
                                print " --- Progam '"+programName+"': Abnormal termination (code ", p.returncode, ") ---"
				return 1
                        else:
                                print " --- Progam '"+programName+"' returned (code ", p.returncode, ") ---"
                                print

                        if (option.RMManager == "copy" and option.itemset != "Y" ) :                        
                                print "The user ran RM_Output_Manager.py with option 'copy'."
                                printName = srcDirName+os.sep+option.intermediateDirName+os.sep
                                print "The intermediate files of ", newDestDirName , " will be stored in ", printName, " for future usage"
                                print
                        else:
                                print "The user decided to avoid running RM_Output_Manager.py with option 'copy'."
                                printName = srcDirName+os.sep+option.intermediateDirName+os.sep
                                print "The program will run using what stored in ", printName, " tha will be moved in ", newDestDirName
                                print
                else :
                        print "RM_Output_Manager.py not run (otpion 'N')."
                        
        except OSError, e:
                print "Execution failed:", e
                

	endTimeRMMan = time.time()
	# Write in the performance file the time elapsed executing this module and the incremental tie from the beginning
	fperf.write (str(endTimeRMMan- startTimeRMMan) + "\t" + str(endTimeRMMan- globalStartTime ) + "\t")

        startTimeCluto = time.time()

        print
        print "  ******** End of "+ programName +" ********"
        print
        
        
        f=open(path+'status.txt','w')	
	f.write('9/11. Executing CLUTO')
	f.close()
        
        programName = option.clusterProgram
        print "  ******** Executing CLUTO "+ programName +" ********"
        print        

        try:
                if option.runCluto == "Y" and option.itemset != "Y" :
                        # Cluto is the C program that execute the clustering. It requires as input the file data_<suffix>.dat that is the modified
                        # version of the output of rapidminer (it has an header line with two values: numebr of rows and columns).
                        # It receives also two files containing the labels of the rows and the columns of the matrix contained in data_<suffix>.dat
                        # the options showfeatures and numer of features are used to make the program show the most discriminative features.
                        # A graphical representation (in gif format) of the cluster is produced.
                        # The number of desired clusters must be passed as input.
                        progPath = workDirName + os.sep + programName
                        ext = os.path.splitext( option.dataFileName )
                        dataFileNameCleaned = ext[0].replace(' ','_') +"_"+option.suffix + ext[1]
                        cfile = newDestDirName +os.sep + option.colLabelFileName
                        rfile = newDestDirName +os.sep + option.rowLabelFileName
                        gifFile = newDestDirName +os.sep + option.plotFileName
                        clutoOptions = "-clmethod=rbr -showfeatures -nfeatures=10 -plotformat=gif -plotclusters="+os.path.normpath(gifFile)+" -clabelfile="+os.path.normpath(cfile)+" -rlabelfile="+os.path.normpath(rfile)
			matrix = os.path.normpath(newDestDirName + os.sep+dataFileNameCleaned)
                        arguments = clutoOptions+" "+ matrix + " " + option.clusterNumber 
                        commandLine = os.path.normpath(progPath) + " " + arguments
                        print 
                        print "Command line used to call CLUTO :"
                        print commandLine
                        print 
                        outPath = newDestDirName + os.sep + option.outputClutoFileName
                        outPath = os.path.normpath(outPath)
                        print 
                        print "Clustering..."
                        print
                        # The output of Cluto is redirected to a file
                        f = open (outPath, mode='w')
                        p = subprocess.Popen(commandLine , stdout=f , shell=True)
                        f.close()
                        #p = subprocess.Popen(commandLine , shell=True)
                        p.wait()
                        if p.returncode != 0:
                                print " --- Progam '"+programName+"': Abnormal termination (code ", p.returncode, ") ---"
				return 1
                        else:
                                print " --- Progam '"+programName+"' returned (code ", p.returncode, ") ---"
                                print
			
			clutoOriginalName = newDestDirName + os.sep + dataFileNameCleaned + ".clustering." +  option.clusterNumber
                        clutoName = newDestDirName + os.sep + "CLUTO_" + option.clusterNumber + "_clusters.dat"
                        os.rename(clutoOriginalName, clutoName)                        

                else :
                        print "CLUTO was not run; no clustering will be executed"
                        
        except OSError, e:
                print "Execution failed:", e


	endTimeCluto = time.time()
	# Write in the performance file the time elapsed executing this module and the incremental tie from the beginning
	fperf.write (str(endTimeCluto- startTimeCluto) + "\t" + str(endTimeCluto- globalStartTime ) + "\t")
	fclu.write (str(option.clusterNumber) + "\t" + str(endTimeCluto- startTimeCluto) + "\n")
	

	startTimeClutoOrg = time.time()


        print
        print "  ******** End of "+ programName +" ********"
        print
        
        f=open(path+'status.txt','w')	
	f.write('10/11. Organizing results')
	f.close()
        
        programName = "Result_organizer.py"
        print "  ******** Executing "+ programName +" ********"
        print

        try:
                # The script exploits the output of CLUTO (a file in which each row correspond to a row of the matrix and so to a file and
                # represents the cluster in which the file must be placed) and moves the files into ad hoc created folders corresponding
                # to the various clusters (it moves the files according to the match between the output file of cluto and the row label file).
                # It creates n folders where n is the number of clusters (the first folder is named '0' the last 'n-1') and a folder
                # where the intermediate results are stored.
                if (option.runCluto == "Y" and option.runOrganizer == "Y" and option.itemset != "Y"):
                        if option.linuxOrNot == "linux" :                                                
                                progPath = "python "+workDirName + os.sep + programName
                        else : 
                                progPath = workDirName + os.sep + programName
                        clutoName = "CLUTO_" + option.clusterNumber + "_clusters.dat"
                        arguments = "-w "+ newDestDirName + " -d "+destDirName+" -i " + option.intermediateDirName + " -n " + option.clusterNumber + " -o " + clutoName + " -r " +option.rowLabelFileName
                        commandLine = progPath + " " + arguments
			print commandLine
                        p = subprocess.Popen(commandLine , shell=True)
                        p.wait()
                        if p.returncode != 0:
                                print " --- Progam '"+programName+"': Abnormal termination (code ", p.returncode, ") ---"
				return 1
                        else:
                                print " --- Progam '"+programName+"' returned (code ", p.returncode, ") ---"
                                print
                else :
                        print "Result_organizer.py (and CLUTO) were not run"
                        
        except OSError, e:
                print "Execution failed:", e

	endTimeClutoOrg = time.time()
	# Write in the performance file the time elapsed executing this module and the incremental tie from the beginning
	fperf.write (str(endTimeClutoOrg- startTimeClutoOrg) + "\t" + str(endTimeClutoOrg- globalStartTime ) + "\t")

	startTimeSumm = time.time()	

	print
        print "  ******** End of "+ programName +" ********"
        print
        
        f=open(path+'status.txt','w')	
	f.write('11/11. Creating summary')
	f.close()
        programName = "Summarizer.py"
        print "  ******** Executing "+ programName +" ********"
        print

        try:
                # This script analyzes the newDestDir (the one were the outputs are stored). It enters in each folder
                # representing a cluster (so not the one in which the intermediate results are stored) and summarizes
                # each file. The output is appended to a single file unique for each folder.
		if option.itemset != "Y" :
			# Executing the summarizer not for the itemsets
			if (option.runSummarizer == "Y"):
		                if option.linuxOrNot == "linux" :                                                
		                        progPath = "python "+workDirName + os.sep + programName
		                else : 
		                        progPath = workDirName + os.sep + programName
		                if option.runCluto == 'N':
		                	os.mkdir(newDestDirName+'0/')
		                	import shutil
		                	for files in os.listdir(srcDirName):
		                		if 'txt' in files:
		                			shutil.copy(srcDirName+files, newDestDirName+'0/')
		                	os.mkdir(newDestDirName+option.intermediateDirName)
		                	shutil.copy(srcDirName+option.intermediateDirName+os.sep+option.hashFileName, newDestDirName+option.intermediateDirName+os.sep+option.hashFileName)
		                	os.remove(newDestDirName+option.hashFileName)
		                arguments = "-w "+ newDestDirName + " --sourceDirName " + srcDirName + " -i " + option.intermediateDirName + " --hashfileName "+option.hashFileName + " -n "+ option.summaryFileName + " --summSorted "+option.summarySorted + " -r " + option.ratio + " --scoreSummSuffix " + option.scoreSummSuffix +" --score " + option.scoreOrNot + " -l "+ option.linuxOrNot
				print arguments
		                commandLine = progPath + " " + arguments
		                p = subprocess.Popen(commandLine , shell=True)
		                p.wait()
		                if p.returncode != 0:
		                        print " --- Progam '"+programName+"': Abnormal termination (code ", p.returncode, ") ---"
					return 1
		                else:
		                        print " --- Progam '"+programName+"' returned (code ", p.returncode, ") ---"
		                        print

		        else :
		                print "Summarizer.py was not run"
		else:
			# Executing the summarizer for the itemsets
			if (option.runSummarizer == "Y"):
				if option.linuxOrNot == "linux" :                                                
					programName = "Summarizer_Freq_Itemset.py" 
		                        progPath = "python "+workDirName+os.sep+"Frequent_Itemsets" + os.sep + programName
		                else : 
		                        progPath = workDirName + os.sep + programName
		                arguments = "-w "+ newDestDirName + " -i " + option.intermediateDirName + " -n "+ option.summarySuffix + " -v "+ dictionaryIDFileName+ " -p " + stopWordsFileName + " -r " + option.ratio + " -t " + transactionSumm + " --hashfileName "+option.hashFileName + " --sourceDirName " + srcDirName + " -l "+ option.linuxOrNot
		                commandLine = progPath + " " + arguments
		                p = subprocess.Popen(commandLine , shell=True)
		                p.wait()
		                if p.returncode != 0:
		                        print " --- Progam '"+programName+"': Abnormal termination (code ", p.returncode, ") ---"
					return 1
		                else:
		                        print " --- Progam '"+programName+"' returned (code ", p.returncode, ") ---"
		                        print

		        else :
		                print "Summarizer.py was not run"
                        
        except OSError, e:
                print "Execution failed:", e	

        print
        print "  ******** End of "+ programName +" ********"
        print
	
	endTimeSumm = time.time()	
	# Write in the performance file the time elapsed executing this module and the incremental tie from the beginning
	fperf.write (str(endTimeSumm- startTimeSumm) + "\t" + str(endTimeSumm- globalStartTime ) + "\n")	
	fsumm.write (str(option.ratio) + "\t" + str(endTimeSumm- startTimeSumm) + "\n")

	fperf.close()
	fclu.close()
	fsumm.close()
	
	#return
        return 0
                

if __name__ == "__main__":
	# Someone is launching this directly
	ret = main()
	if ret == 1 :
		os._exit(1)
	os._exit(0)
