from xml.etree.ElementTree import ElementTree
from optparse import OptionParser
import os
import shutil

def main():
        p = OptionParser()
        p.add_option("--workDirectory", "-w", dest="workDirNameNB", default="F:\\@_Lorenzo\\@_Tesi\\@_Framework_Parts", help="Absolute path of the directory pieces of the framework are stored")
        p.add_option("--srcDirectory", "-s", dest="dirnameNB", default="F:\\Text_Selection\\", help="Absolute path of the directory where articles (after having been processed by the cleaner) are stored")
        p.add_option("--dstDirectory", "-d", dest="destDirnameNB", default="F:\\Experimental_Results\\", help="Absolute path of the directory where the selected parts of the articles are stored")
        p.add_option("--intDirectory", "-i", dest="intermediateDirName", default="Intermediate", help="Name of the directory where to store the intermediary processing files (Ex. data.dat)")	
        p.add_option("--linux", "-l", dest="linuxOrNot", default="", help="If not set -> working under Windows; if set to linux working under Linux")
        
        option, arguments = p.parse_args()

        if option.linuxOrNot == "linux" :
                workDirName = option.workDirNameNB.replace('%20', ' ')
		workDirName = workDirName.replace("F:\\", "/media/DATI/")
		workDirName = workDirName.replace('\\', '/')
                dirname = option.dirnameNB.replace('%20', ' ')
		dirname = dirname.replace("F:\\", "/media/DATI/")
		dirname = dirname.replace('\\', '/')
		destDirname = option.destDirnameNB.replace('%20', ' ')
		destDirname = destDirname.replace("F:\\", "/media/DATI/")
		destDirname = destDirname.replace('\\', '/')
	else :
                workDirName = option.workDirNameNB.replace('%20', ' ')
                dirname = option.dirnameNB.replace('%20', ' ')
		destDirname = option.destDirnameNB.replace('%20', ' ')

        
        #Testing the output directory
       
        i = 1
	print destDirname 
        outputDirName = destDirname +os.sep        
        while (os.path.exists(outputDirName)) :
                outputDirName = os.path.dirname(destDirname) +"_" + str(i) + os.sep
                i += 1

        print " --- Working directories --- "
        print
        print "Source directory: "+dirname
        print "Destination directory: "+outputDirName        
        print

        tmpFileName = os.path.normpath(workDirName + os.sep + "tmp.txt")
        f = open (tmpFileName, mode='w')
        f.write(outputDirName)
        f.close()

        os.mkdir(outputDirName)      

        i = 0
        for fileName in os.listdir(dirname) :
                if (fileName != option.intermediateDirName) : # It's not the directory Intermediate

                        # Absolute path and name of the source file
                        source = os.path.normpath(dirname+os.sep+fileName)
                        # Absolute path and name of the destination file
                        dest = os.path.normpath(outputDirName+os.sep+fileName)
                        shutil.copy(source,dest)                
                        i += 1

	#pathHashSrc = os.path.normpath(dirname +os.sep+option.intermediateDirName+os.sep+option.hashFileName)
	#pathHashDst = os.path.normpath(outputDirName +os.sep+option.hashFileName)
	#if (os.path.exists(pathHashSrc)) :
		#shutil.copy(pathHashSrc,pathHashDst)                
	#else :
		#print "Hash file not copied"

        print i , "files were copied"
        print 
                
        return


if __name__ == "__main__":
	# Someone is launching this directly
	main()
