from optparse import OptionParser
from math import sqrt
import os
import shutil

def main():
        p = OptionParser()
        p.add_option("--dirname", "-d", dest="dirname", default="/media/DATI/@_Lorenzo/@_Tesi/Results/Alfa_Beta_Gamma_Evaluation/Top_20_More_Info_normalized_less_gamma/", help="Basedir of the experiemnt results")
        p.add_option("--prefix", "-p", dest="prefix", default="Average_Values", help="")
        p.add_option("--fileName", "-f", dest="fn", default="Avg_Recall", help="Name of the file with the results")
        
        option, arguments = p.parse_args()        	
	
	
	sourceFile = os.path.normpath(option.dirname+os.sep+option.prefix+os.sep+option.fn+".txt") 
	dstFile = os.path.normpath(option.dirname+os.sep+option.prefix+os.sep+option.fn+"_to_plot.dat") 
	fileParse(sourceFile,dstFile)
                
        return


def fileParse(source,dest):
        
        f = open (source, mode='r')
        fw = open (dest, mode='w')
	selector = "REC"
        
	#header = 1 #For cluster that has not the header line
	header = 0 # For all the other files
	linecounter = 1
	gnuplot_string = ""
        for line in f :
		if header == 0: # skip the header line
			header = 1 
			continue
		else :
		        metrics = line.strip().split()		        
		        if len(metrics) >= 2: # There must be at least two values in the line
				a = metrics[0]
				b = metrics[1]
				c = metrics[2]
				if (selector == "REC"):
					tot = metrics[3]
					fw.write(a+"-"+b+"-"+c+ " "+ tot+ "\n")  	
				if (selector == "SCORE"):
					gene = metrics[3]
					ots = metrics[4]
					fw.write(a+"-"+b+"-"+c+ " "+ gene+ " "+ots+ "\n")  	
				if (b == "0.1" or b == "0.3" or b == "0.6" or b == "0.9"):
					#print "ok"
					if (c == "0.0"):						
						gnuplot_string += "\""+a+"-"+b+"-"+c+"\""+ " " + str(linecounter) + ", "
				linecounter += 1
	fw.write(gnuplot_string+ "\n")        	
        f.close()
	fw.close()
        
        return


if __name__ == "__main__":
	# Someone is launching this directly
	main()
