from optparse import OptionParser
import os

def main():
        p = OptionParser()
	p.add_option("--sourceFileName", dest="src", default="F:\\@_Lorenzo\\@_Tesi\\Results\\Alfa_Beta_Gamma_Evaluation\\Top_20_More_Info_normalized_less_gamma\\Vaccin\\Measures_Total.txt", help="")
	p.add_option("--sourceFileNamePerc", dest="srcPerc", default="F:\\@_Lorenzo\\@_Tesi\\Results\\Alfa_Beta_Gamma_Evaluation\\Top_20_More_Info_normalized_less_gamma\\Vaccin\\Measures_Perc.txt", help="")
	p.add_option("--destRecall", dest="dstRecall", default="F:\\@_Lorenzo\\@_Tesi\\Results\\Alfa_Beta_Gamma_Evaluation\\Top_20_More_Info_normalized_less_gamma\\Vaccin\\Recall", help="")
        p.add_option("--destScore", dest="dstScore", default="F:\\@_Lorenzo\\@_Tesi\\Results\\Alfa_Beta_Gamma_Evaluation\\Top_20_More_Info_normalized_less_gamma\\Vaccin\\Score", help="")
	p.add_option("--cumulGene", dest="cumGene", default="F:\\@_Lorenzo\\@_Tesi\\Results\\Alfa_Beta_Gamma_Evaluation\\Golden\\Golden_Vaccin\\Golden_Gene_Cumulative.txt", help="")
	p.add_option("--cumulBucket", dest="cumOTS", default="F:\\@_Lorenzo\\@_Tesi\\Results\\Alfa_Beta_Gamma_Evaluation\\Golden\\Golden_Vaccin\\Golden_OTS_Cumulative.txt", help="")
	p.add_option("--suffix", dest="suffix", default="_Sorted", help="")
	p.add_option("--extension", dest="ext", default=".txt", help="")
	p.add_option("--linux", "-l", dest="linuxOrNot", default="linux", help="If not set -> working under Windows; if set to linux working under Linux")
	
        option, arguments = p.parse_args()

	if option.linuxOrNot == "linux" :
		src = option.src.replace('%20', ' ')
		src = src.replace("F:\\", "/media/DATI/")
		src = src.replace('\\', '/')
		srcPerc = option.srcPerc.replace('%20', ' ')
		srcPerc = srcPerc.replace("F:\\", "/media/DATI/")
		srcPerc = srcPerc.replace('\\', '/')
		dstRecall = option.dstRecall.replace('%20', ' ')
		dstRecall = dstRecall.replace("F:\\", "/media/DATI/")
		dstRecall = dstRecall.replace('\\', '/')
		dstScore = option.dstScore.replace('%20', ' ')
		dstScore = dstScore.replace("F:\\", "/media/DATI/")
		dstScore = dstScore.replace('\\', '/')
		cumGene = option.cumGene.replace('%20', ' ')
		cumGene = cumGene.replace("F:\\", "/media/DATI/")
		cumGene = cumGene.replace('\\', '/')
		cumOTS = option.cumOTS.replace('%20', ' ')
		cumOTS = cumOTS.replace("F:\\", "/media/DATI/")
		cumOTS = cumOTS.replace('\\', '/')
	else :
		src = option.src
		srcPerc = option.srcPerc
		dstRecall = option.dstRecall
		dstScore = option.dstScore
		cumGene = option.cumGene
		cumOTS = option.cumOTS

	#Extracting the cumulative from the files
	fcg = open(cumGene, 'r')
	cumulGene = []
	for line in fcg:
		values = line.strip().split()
		cumulGene.append(int(values[1]))
	fcg.close()		

	fco = open(cumOTS, 'r')
	cumulOTS = []
	for line in fco:
		values = line.strip().split()
		cumulOTS.append(int(values[1]))
	fco.close()		

	fp = open(srcPerc, 'r')
	frec = open(dstRecall+option.ext, 'w')
	frecs = open(dstRecall+option.suffix+option.ext, 'w')
	recall = []
	recallNoSort = []
	header = 0
	for line in fp:
		if header == 0:
			header = 1 
			continue
		else :
			v = line.strip().split()
			alfa = float(v[0])
			beta = float(v[1])
			gamma = float(v[2])
			# Working for recall
			rg = float(v[3])
			ro = float(v[4])
			rs = float(v[5])
			rtot = rg+ro-rs
			tokenR = [alfa, beta, gamma, rtot, rg, ro, rs]
			recall.append(tokenR)	
			recallNoSort.append(tokenR)

	recall.sort(myCompareRecall)
	frec.write("Alfa\tBeta\tGamma\tR_TOT\tR_GENE\tR_SHR\tR_OTS\n")
	frecs.write("Alfa\tBeta\tGamma\tR_TOT\tR_GENE\tR_SHR\tR_OTS\n")
	for i in range(0,len(recall)):
		frec.write(str(recallNoSort[i][0])+"\t"+str(recallNoSort[i][1])+"\t"+str(recallNoSort[i][2])+"\t"+'%.5f' %(recallNoSort[i][3])+"\t"+'%.5f' %(recallNoSort[i][4])+"\t"+'%.5f' %(recallNoSort[i][6])+"\t"+'%.5f' %(recallNoSort[i][5]) + "\n")
		frecs.write(str(recall[i][0])+"\t"+str(recall[i][1])+"\t"+str(recall[i][2])+"\t"+'%.5f' %(recall[i][3])+"\t"+'%.5f' %(recall[i][4])+"\t"+'%.5f' %(recall[i][6])+"\t"+'%.5f' %(recall[i][5]) + "\n")
	frec.close()
	fp.close()

	f = open(src, 'r')
	fscr = open(dstScore+option.ext, 'w')
	fscrs = open(dstScore+option.suffix+option.ext, 'w')
	scoreGene = []
	scoreGeneNoSort = []
	header = 0
	for line in f:
		if header == 0:
			header = 1 
			continue
		else :
			v = line.strip().split()
			alfa = float(v[0])
			beta = float(v[1])
			gamma = float(v[2])
			# Working for recall
			totSentence = int(v[6])
			maxPossibleGene = cumulGene[totSentence-1]
			print maxPossibleGene, " ", 
			sGene = int(v[7])
			minGene = int(v[8])
			maxGene = int(v[9])
			normScore = (sGene*1.0)/maxPossibleGene
			maxPossibleOTS = totSentence * 20 #20 is the highest bucket
			sOTS = int(v[10])
			normOTS = (sOTS*1.0)/maxPossibleOTS
			tokenS = [alfa, beta, gamma, normScore, minGene, maxGene, normOTS]
			scoreGeneNoSort.append(tokenS)	
			scoreGene.append(tokenS)	

	scoreGene.sort(myCompareScoreGene)
	fscr.write("Alfa\tBeta\tGamma\tGENE\tOTS\tMIN_GENE\n")
	fscrs.write("Alfa\tBeta\tGamma\tGENE\tOTS\tMIN_GENE\n")
	for i in range(0,len(scoreGene)):
		fscr.write(str(scoreGeneNoSort[i][0])+"\t"+str(scoreGeneNoSort[i][1])+"\t"+str(scoreGeneNoSort[i][2])+"\t"+'%.5f' %(scoreGeneNoSort[i][3])+"\t"+'%.5f' %(scoreGeneNoSort[i][6])+"\t"+str(scoreGeneNoSort[i][4])+"\n")
		fscrs.write(str(scoreGene[i][0])+"\t"+str(scoreGene[i][1])+"\t"+str(scoreGene[i][2])+"\t"+'%.5f' %(scoreGene[i][3])+"\t"+'%.5f' %(scoreGene[i][6])+"\t"+str(scoreGene[i][4])+"\n")
	fscr.close()
	f.close()

	return

def myCompareRecall(token1, token2):
	totRecall1 = float(token1[3])
	totRecall2 = float(token2[3])
	rGene1 = float(token1[4])
	rGene2 = float(token2[4])
	rShare1 = float(token1[6])
	rShare2 = float(token2[6])
	rOTS1 = float(token1[5])
	rOTS2 = float(token2[5])
	if cmp (totRecall2,totRecall1) != 0:
		return cmp (totRecall2,totRecall1)
	if cmp (rGene2,rGene1) != 0:
		return cmp (rGene2,rGene1)
	if cmp (rShare2,rShare1) != 0:
		return cmp (rShare2,rShare1)
	return cmp (rOTS2,rOTS1)

def myCompareScoreGene(token1, token2):
	scoreGene1 = float(token1[3])
	scoreGene2 = float(token2[3])
	scoreOTS1 = float(token1[6])
	scoreOTS2 = float(token2[6])
	minGene1 = int(token1[4])
	minGene2 = int(token2[4])
	if cmp (scoreGene2,scoreGene1) != 0:
		return cmp (scoreGene2,scoreGene1)
	if cmp (scoreOTS2,scoreOTS1) != 0:
		return cmp (scoreOTS2,scoreOTS1)
	return cmp (minGene2,minGene1)


if __name__ == "__main__":
	# Someone is launching this directly
	main()
