#! /usr/bin/env python

import gobject
import biosumm
import gtk
import time
import subprocess



def autoLauncher(query, numEl, engine, journal):
#	gtk.main()
	a.wTree.get_widget('entryKey').set_text(query)
	a.wTree.get_widget('spinbutton1').set_value(numEl)
	a.wTree.get_widget('search_engine').set_active(engine)
	if journal != '-':
		a.wTree.get_widget('journalKey').set_text(journal)
	#time.sleep(2)
	#Search
	a.wTree.get_widget('buttonSearch').emit('clicked')
#	gtk.mainloop()
	while not a.wTree.get_widget('buttonDownload1').get_property('sensitive'):
		time.sleep(2.0)
#	gtk.main()
	a.wTree.get_widget('buttonDownload1').emit('clicked')
#	gtk.main()
	while not a.wTree.get_widget('buttonSummarize').get_property('sensitive'):
		time.sleep(2.0)
	a.wTree.get_widget('buttonSummarize').emit('clicked')
	while not a.wTree.get_widget('progressbar1').get_text() == 'Summarize done!':
		time.sleep(2.0)
	a.wTree.get_widget('buttonClear').emit('clicked')
	

gobject.threads_init()
a=biosumm.search()
f=open('stats.txt','w')
f.write('\nQuery\t\t\t\tJournal\tClutering\tElements\tSearch engine\tTTSearch\tTTDownload\tTTSumm\t\tWord Count\n-----------------------------------------------------------------------------------------------------------------------------\n\n')
f.close()

#queryList=['breast cancer', 'breast cancer epidemiology']
queryList=['microarray' , 'cancer' , 'TP53']
#queryList=['breast cancer']
#journalList = ['Psychooncology','Cancer Invest','Nucleic Acid Res']
journal = 'Nucleic Acid Res'
journal = '-'
# Google Scholar
#sE=1
#for i in range(1, 11):
#	for query in queryList:
#		num=i*10

#		if len(query)<9:
#			tabs='\t\t\t\t'
#		elif len(query)<17:	
#			tabs='\t\t\t'	
#		elif len(query)<25:
#			tabs='\t\t'
#		else: tabs='\t'
#		
#		f=open('stats.txt', 'a')
#		f.write(query + tabs + journal +'\tY\t\t' +str(num) + '\t\t'+str(sE)+'\t\t' )
#		f.close()
#		autoLauncher(query, num, sE)

# PubMed Central
#sE = 2
#for i in range(7, 11):
#	for query in queryList:
#		for exp in range(1, 2):
#			num=i*10
#	
#			if len(query)<9:	
#				tabs='\t\t\t\t'	
#			elif len(query)<17:	
#				tabs='\t\t\t'	
#			elif len(query)<25:
#				tabs='\t\t'
#			else: tabs='\t'
#				
#			f=open('stats.txt', 'a')
#			f.write(query + '\t' + journal +'\tY\t\t' +str(num) + '\t\t'+str(sE)+'\t\t' )
#			f.close()
#			autoLauncher(query, num, sE, journal)

# PubMed
sE=1
for i in range(1, 5):
	for query in queryList:
		for exp in range(1, 4):
			num=i*10

			if len(query)<9:	
				tabs='\t\t\t\t'
			elif len(query)<17:	
				tabs='\t\t\t'	
			elif len(query)<25:
				tabs='\t\t'
			else: tabs='\t'
				
			f=open('stats.txt', 'a')
			f.write(query + tabs + journal +'\tY\t\t' +str(num) + '\t\t'+str(sE)+'\t\t' )
			#f.write(query +'\t10\t\t' +str(num) + '\t\t'+str(sE)+'\t\t' )
			f.close()
			autoLauncher(query, num, sE, journal)


gtk.main()


