
class setdate:
    def __init__(self, wTree):
    	self.wTree = wTree

    	
    def setdata(self, widget):
    	self.window2 = self.wTree.get_widget("set_date")
    	self.window2.show()
    	
    	dicData = {
            "on_OKdata_clicked" : self.saveData,
            "on_cancelData_clicked" : self.closeData,
            "on_clearData_clicked" : self.clearData,
            "on_sYear_output" : self.setStartYear,
        }

        self.wTree.signal_autoconnect( dicData )

    
    
    def setStartYear(self, widget):
    	print self
    	print widget
        self.sY = self.wTree.get_widget("sYear").get_value_as_int()


    
    def saveData(self, widget):
    	'''
    	When clicking OK in the date window this function is called.
    	It saves the date set by the user.
    	'''
    	
    	if self.wTree.get_widget("absDate").get_active():
    		# Absolute date
    		self.wTree.get_widget("sYear").update()
    		sM = self.wTree.get_widget("sMonth").get_active()
    		sY = self.wTree.get_widget("sYear").get_value_as_int()
    		eM = self.wTree.get_widget("eMonth").get_active()
    		self.wTree.get_widget("eYear").update()
    		eY = self.wTree.get_widget("eYear").get_value_as_int()
	
    		if sM == 0 or sM == -1:
    			sM = 1
    		if eM == 0 or eM == -1:
    			eM = 12
    		#Saves date
    		stDH = self.wTree.get_widget("startdata")
    		endDH = self.wTree.get_widget("enddata")
    		stDH.set_text(str(sY) + '/' + str(sM))
    		stDH.show()
    		endDH.set_text(str(eY) + '/' + str(eM))
    		endDH.show()
    		self.wTree.get_widget("startDateLabel").show()
    		self.wTree.get_widget("endDateLabel").show()
    	else:
    		# Relative date
    		reldate = str(int(self.wTree.get_widget("hscale1").get_value()))
		nd = self.wTree.get_widget("numdayslab")
		nd.set_text(reldate)
		self.wTree.get_widget("lastlabel").show()
		self.wTree.get_widget("dayslabel").show()
		nd.show()
    		
    	self.window2.hide()
    
    
    def closeData(self, widget):
    	self.window2.hide()
    	
    	
    def clearData(self, widget):
    	'''
    	Used to set no date. It clears all previous
    	values of dates.
    	'''
    	sd = self.wTree.get_widget("startdata")
    	sd.set_text("1800/1")
    	sd.hide()
    	ed = self.wTree.get_widget("enddata")
    	ed.set_text("2100/12")
    	ed.hide()
    	self.wTree.get_widget("startDateLabel").hide()
    	self.wTree.get_widget("endDateLabel").hide()
    	self.wTree.get_widget("hscale1").set_value(1000)
    	self.wTree.get_widget("lastlabel").hide()
	self.wTree.get_widget("dayslabel").hide()
	self.wTree.get_widget("numdayslab").hide()
    	self.window2.hide()

	
